Solid Example: Batch

import { For, createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { batch } from '@tanstack/solid-pacer/batcher'

function App1() {
  const [batchItems, setBatchItems] = createSignal<Array<number>>([])
  const [processedBatches, setProcessedBatches] = createSignal<
    Array<Array<number>>
  >([])

  // Create the batcher function
  const addToBatch = batch<number>(
    (items) => {
      setProcessedBatches((prev) => [...prev, items])
      console.log('Processing batch', items)
    },
    {
      maxSize: 5,
      wait: 3000,
      getShouldExecute: (items) => items.includes(42),
      onItemsChange: (batcherInstance) => {
        setBatchItems(batcherInstance.peekAllItems())
      },
    },
  )

  return (
    <div>
      <h1>TanStack Pacer batcher Example 1</h1>
      <div>Batch Items: {batchItems().join(', ')}</div>
      <div>
        Processed Batches:{' '}
        <For each={processedBatches()}>
          {(b) => <span>[{b.join(', ')}], </span>}
        </For>
      </div>
      <button
        onClick={() => {
          const nextNumber = batchItems().length
            ? batchItems()[batchItems().length - 1] + 1
            : 1
          addToBatch(nextNumber)
        }}
      >
        Add Number
      </button>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
    </div>
  ),
  document.getElementById('root')!,
)
import { For, createSignal } from 'solid-js'
import { render } from 'solid-js/web'
import { batch } from '@tanstack/solid-pacer/batcher'

function App1() {
  const [batchItems, setBatchItems] = createSignal<Array<number>>([])
  const [processedBatches, setProcessedBatches] = createSignal<
    Array<Array<number>>
  >([])

  // Create the batcher function
  const addToBatch = batch<number>(
    (items) => {
      setProcessedBatches((prev) => [...prev, items])
      console.log('Processing batch', items)
    },
    {
      maxSize: 5,
      wait: 3000,
      getShouldExecute: (items) => items.includes(42),
      onItemsChange: (batcherInstance) => {
        setBatchItems(batcherInstance.peekAllItems())
      },
    },
  )

  return (
    <div>
      <h1>TanStack Pacer batcher Example 1</h1>
      <div>Batch Items: {batchItems().join(', ')}</div>
      <div>
        Processed Batches:{' '}
        <For each={processedBatches()}>
          {(b) => <span>[{b.join(', ')}], </span>}
        </For>
      </div>
      <button
        onClick={() => {
          const nextNumber = batchItems().length
            ? batchItems()[batchItems().length - 1] + 1
            : 1
          addToBatch(nextNumber)
        }}
      >
        Add Number
      </button>
    </div>
  )
}

render(
  () => (
    <div>
      <App1 />
    </div>
  ),
  document.getElementById('root')!,
)

Docs
Cloudflare
Railway
CodeRabbit
Clerk
SerpAPI
Netlify
WorkOS
OpenRouter
AG Grid
Prisma
Sentry
Unkey
Electric
Cloudflare
Railway
CodeRabbit
Clerk
SerpAPI
Netlify
WorkOS
OpenRouter
AG Grid
Prisma
Sentry
Unkey
Electric
Debouncer API Reference
Throttler API Reference
Rate Limiter API Reference
Queue API Reference
Batcher API Reference

React Example: Batch

import { useCallback, useState } from 'react'
import ReactDOM from 'react-dom/client'
import { batch } from '@tanstack/react-pacer/batcher'

function App() {
  const [processedBatches, setProcessedBatches] = useState<
    Array<Array<number>>
  >([])
  const [batchItems, setBatchItems] = useState<Array<number>>([])

  // Create the batcher function only once using useCallback
  const addToBatch = useCallback(
    batch<number>(
      (items) => {
        setProcessedBatches((prev) => [...prev, items])
        console.log('Processing batch', items)
      },
      {
        maxSize: 5,
        wait: 3000,
        getShouldExecute: (items) => items.includes(42),
        onItemsChange: (batcherInstance) => {
          setBatchItems(batcherInstance.peekAllItems())
        },
      },
    ),
    [], // must be memoized to avoid re-creating the batcher on every render (consider using useBatcher instead in react)
  )

  return (
    <div>
      <h1>TanStack Pacer batcher Example</h1>
      <div>Batch Items: {batchItems.join(', ')}</div>
      <div>
        Processed Batches:{' '}
        {processedBatches.map((b, i) => (
          <span key={i}>[{b.join(', ')}], </span>
        ))}
      </div>
      <button
        onClick={() => {
          const nextNumber = batchItems.length
            ? batchItems[batchItems.length - 1] + 1
            : 1
          addToBatch(nextNumber)
        }}
      >
        Add Number
      </button>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(<App />)
import { useCallback, useState } from 'react'
import ReactDOM from 'react-dom/client'
import { batch } from '@tanstack/react-pacer/batcher'

function App() {
  const [processedBatches, setProcessedBatches] = useState<
    Array<Array<number>>
  >([])
  const [batchItems, setBatchItems] = useState<Array<number>>([])

  // Create the batcher function only once using useCallback
  const addToBatch = useCallback(
    batch<number>(
      (items) => {
        setProcessedBatches((prev) => [...prev, items])
        console.log('Processing batch', items)
      },
      {
        maxSize: 5,
        wait: 3000,
        getShouldExecute: (items) => items.includes(42),
        onItemsChange: (batcherInstance) => {
          setBatchItems(batcherInstance.peekAllItems())
        },
      },
    ),
    [], // must be memoized to avoid re-creating the batcher on every render (consider using useBatcher instead in react)
  )

  return (
    <div>
      <h1>TanStack Pacer batcher Example</h1>
      <div>Batch Items: {batchItems.join(', ')}</div>
      <div>
        Processed Batches:{' '}
        {processedBatches.map((b, i) => (
          <span key={i}>[{b.join(', ')}], </span>
        ))}
      </div>
      <button
        onClick={() => {
          const nextNumber = batchItems.length
            ? batchItems[batchItems.length - 1] + 1
            : 1
          addToBatch(nextNumber)
        }}
      >
        Add Number
      </button>
    </div>
  )
}

const root = ReactDOM.createRoot(document.getElementById('root')!)
root.render(<App />)

TanStack

Svelte Example: Batch

<script lang="ts">
  import { TanStackDevtools } from '@tanstack/svelte-devtools'
  import { pacerDevtoolsPlugin } from '@tanstack/svelte-pacer-devtools'
  import { batch } from '@tanstack/svelte-pacer/batcher'

  let processedBatches = $state<Array<Array<number>>>([])

  let batchItems = $state<Array<number>>([])

  // Create the batcher once during component initialization.
  const addToBatch = batch<number>(
    (items) => {
      processedBatches = [...processedBatches, items]
      console.log('Processing batch', items)
    },
    {
      maxSize: 5,
      wait: 3000,
      getShouldExecute: (items) => items.includes(42),
      onItemsChange: (batcherInstance) => {
        batchItems = batcherInstance.peekAllItems()
      },
    },
  )
</script>

<div>
  <h1>TanStack Pacer batcher Example</h1>
  <div>Batch Items: {batchItems.join(', ')}</div>
  <div>
    {'Processed Batches: '}{#each processedBatches as b, i (i)}<span
        >[{b.join(', ')}],
      </span>{/each}
  </div>
  <button
    onclick={() => {
      const nextNumber = batchItems.length
        ? batchItems[batchItems.length - 1]! + 1
        : 1
      addToBatch(nextNumber)
    }}
  >
    Add Number
  </button>
</div>
{#if import.meta.env.DEV}<TanStackDevtools
    plugins={[pacerDevtoolsPlugin()]}
  />{/if}

TanStack
<script setup lang="ts">
import { TanStackDevtools } from '@tanstack/vue-devtools'
import { pacerDevtoolsPlugin } from '@tanstack/vue-pacer-devtools'
import { ref } from 'vue'
import { batch } from '@tanstack/vue-pacer/batcher'

const dev = import.meta.env.DEV
const plugins = [pacerDevtoolsPlugin()]

const processedBatches = ref<Array<Array<number>>>([])

const batchItems = ref<Array<number>>([])

// Create the batcher once during setup.
const addToBatch = batch<number>(
  (items) => {
    processedBatches.value = [...processedBatches.value, items]
    console.log('Processing batch', items)
  },
  {
    maxSize: 5,
    wait: 3000,
    getShouldExecute: (items) => items.includes(42),
    onItemsChange: (batcherInstance) => {
      batchItems.value = batcherInstance.peekAllItems()
    },
  },
)
</script>

<template>
  <div>
    <h1>TanStack Pacer batcher Example</h1>
    <div>Batch Items: {{ batchItems.join(', ') }}</div>
    <div>
      {{ 'Processed Batches: '
      }}<template v-for="(b, i) in processedBatches" :key="i"
        ><span>[{{ b.join(', ') }}], </span></template
      >
    </div>
    <button
      @click="
        () => {
          const nextNumber = batchItems.length
            ? batchItems[batchItems.length - 1]! + 1
            : 1
          addToBatch(nextNumber)
        }
      "
    >
      Add Number
    </button>
  </div>
  <TanStackDevtools v-if="dev" :plugins="plugins" />
</template>